*! version 0.1.1 2013-08-15 | long freese | _rm_modelinfo2

//  sreturns with information about the last estimation command

* major revisions based on info from Jeff P.

capture program drop _rm_modelinfo2
capture program drop fvtype
program define _rm_modelinfo2, rclass

    version 11.2

    local cmdnm "`e(cmd)'"
    if "`cmdnm'"=="" {
        display as error "estimation results are not in memory"
        exit
    }
    local cmdn = e(N)

    * e(b) parameter names
    tempname varinfo betainfo betas
    matrix `betas' = e(b)
    local betanms : colnames `betas'
    local nbetanms = wordcount("`betanms'")
    local betanms : subinstr local betanms "o._cons" " ", all // for ologit etc
    local betanms : subinstr local betanms "_cons" " ", all // for ologit etc
    *local nbetanms = wordcount("`betanms'")
    local nbetanms : list sizeof betanms
    matrix `betainfo' = J(13,`nbetanms',.)
    matrix rownames `betainfo' = ///
        1isbin 2iscat 3Ncats 4catbase 5Nomitted 6isfv 7isint 8intself ///
        9intselfonly 10intother 11factor 12omit 13level
    matrix colnames `betainfo' = `betanms'

    local cmdbin = 0
    if "`cmdnm'"=="logit" | "`cmdnm'"=="probit" | "`cmdnm'"=="cloglog" {
        local cmdbin = 1
    }

    local cmdnrm = 0
    if "`cmdnm'"=="mlogit" | "`cmdnm'"=="mprobit" | "`cmdnm'"=="slogit" {
        local cmdnrm = 1
    }

    local cmdcrm = 0
    if "`cmdnm'"=="poisson"   | "`cmdnm'"=="nbreg" | "`cmdnm'"=="zip" ///
      | "`cmdnm'"=="zinb"     | "`cmdnm'"=="ztp"   | "`cmdnm'"=="ztnb" ///
      | "`cmdnm'"=="tpoisson" | "`cmdnm'"=="tnbreg" {
        local cmdcrm = 1
    }

    local cmdsvy = 0
    if ("`e(prefix)'"=="svy") local cmdsvy = 1

    local lhsnm "`e(depvar)'"
    if "`e(cmd)'"=="intreg" {
        local lhsnm2 : word 2 of `lhsnm'
        local lhsnm  : word 1 of `lhsnm'
    }

    local lhsbaseval = .
    if ("`e(cmd)'"=="mlogit") local lhsbaseval = e(baseout)
    if ("`e(cmd)'"=="mprobit") local lhsbaseval = e(i_base)

    _rm_rhsnames rhsnms rhsn rhsnms2 rhsn2
    local lhscatn = e(k_cat)
    if `cmdnrm' local lhscatn = e(k_out)
    if `cmdbin' local lhscatn = 2
    qui tab `lhsnm' if e(sample)
    local lhsvalues = r(r)
    if `lhscatn'==. {
        local lhscatn = 0
        local lhscatnms ""
        local lhscatvals ""
        local lhscatnms8 ""
    }
    else {
        qui sum `lhsnm' if e(sample)
        local lmin = r(min)
        _labels2names `lhsnm' if e(sample), indexfrom(`lmin')
        local lhscatnms "`s(labels)'"

        _labels2names `lhsnm' if e(sample), indexfrom(`lmin') nolabel
        local lhscatvals "`s(labels)'"
        local ln = s(n_cat)
        if `lhscatn'!=`ln' {
            di as error "_rm_modelinfo error: e(k_cat)!=s(n_cat)"
            exit
        }
        local lhscatnms8 ""
        foreach cnm in `lhscatnms' {
            local cnm = substr("`cnm'",1,8)
            *            local lhscatnms8 "`lhscatnms8'`cnm' "
            local lhscatnms8 "`lhscatnms8' `"`cnm'"' " // 1.1.12
        }
    }

//  fv types

    fvtype , rhs_beta(`rhsnms')
*sreturn list
    foreach varset in cat bin core typeintprod typefactor ///
            typevariable nfactor {
        local rhs_`varset' "`s(rhs_`varset')'"
        local rhs_`varset' = ltrim("`rhs_`varset''")
    }

    if "`rhsnms2'"!="" {
        _rm_fvtype , rhs_beta(`rhsnms2')
        foreach varset in cat bin core typeintprod typefactor ///
                typevariable nfactor {
            local rhs2_`varset' "`s(rhs_`varset')'"
            local rhs2_`varset' = ltrim("`rhs2_`varset''")
        }
    }
    local nrhs_core = wordcount("`rhs_core'")
    matrix `varinfo' = J(6,`nrhs_core',.)
    matrix rownames `varinfo' = ///
        1bin 2cat 3typeint 4typefac 5typevar 6Ncats // 7base 8Nommited
*        1isbin 2iscat 3Ncats 4catbase 5Nomitted 6isfv 7isint 8intself ///
*        9intselfonly 10intother
    matrix colnames `varinfo' = `rhs_core'

    * is it binary?
    foreach nm in `s(rhs_bin)' {
        matrix `varinfo'[1,colnumb(`varinfo',"`nm'")] = 1
    }
    * is it categorical?
    foreach nm in `s(rhs_cat)' {
        matrix `varinfo'[2,colnumb(`varinfo',"`nm'")] = 1
    }
    * is it typeint?
    foreach nm in `s(rhs_typeintprod)' {
        matrix `varinfo'[3,colnumb(`varinfo',"`nm'")] = 1
    }
    * is it typefac?
    local i = 0
    foreach nm in `s(rhs_typefactor)' {
        matrix `varinfo'[4,colnumb(`varinfo',"`nm'")] = 1
        local ++i
        local nfac : word `i' of `rhs_nfactor'
        matrix `varinfo'[6,colnumb(`varinfo',"`nm'")] = `nfac'
    }
    * is it typevar?
    foreach nm in `s(rhs_typevariable)' {
        matrix `varinfo'[5,colnumb(`varinfo',"`nm'")] = 1
    }
*        matrix A[rownumb(A,"price"), colnumb(A,"mpg")] = sqrt(2)

*matlist `varinfo'

/*  2013-08-15 info on e(b) might not be needed
            if it is, do this much better!

    * information on parameters in e(b)
    local ibnm = 0
    foreach bnm in `betanms' {

        local ++ibnm
        _ms_parse_parts `bnm'
        local corenm `r(name)'
        local inttype "`r(type)'"
        if "`inttype'"=="interaction" {
            matrix `betainfo'[7,`ibnm'] = 1
            forvalues i = 1(1)6 {
                local deg`i' = 0
                if "`r(name`i')'"!="" local deg`i' = 1
            }
            if `deg6'==1 {
                display as error ///
                "fifth order interactions & higher not supported"
                exit
            }
            if `deg5'==1 {
                if "`r(name1)'"=="`r(name2)'" & "`r(name1)'"=="`r(name3)'" ///
                 & "`r(name1)'"=="`r(name4)'" & "`r(name1)'"=="`r(name5)'" {
                    matrix `betainfo'[8,`ibnm'] = 1 // self
                    matrix `betainfo'[9,`ibnm'] = 1 // self only
                    matrix `betainfo'[10,`ibnm'] = 0 // intother
                }
                else {
                    matrix `betainfo'[8,`ibnm'] = 0 // self
                    matrix `betainfo'[9,`ibnm'] = 0 // self only
                    matrix `betainfo'[10,`ibnm'] = 1 // intother
                }
            }
            if `deg4'==1 {
                if "`r(name1)'"=="`r(name2)'" & "`r(name1)'"=="`r(name3)'" ///
                 & "`r(name1)'"=="`r(name4)'" {
                    matrix `betainfo'[8,`ibnm'] = 1 // self
                    matrix `betainfo'[9,`ibnm'] = 1 // self only
                    matrix `betainfo'[10,`ibnm'] = 0 // intother
                }
                else {
                    matrix `betainfo'[8,`ibnm'] = 0 // self
                    matrix `betainfo'[9,`ibnm'] = 0 // self only
                    matrix `betainfo'[10,`ibnm'] = 1 // intother
                }
            }
            if `deg3'==1 {
                if "`r(name1)'"=="`r(name2)'" & "`r(name1)'"=="`r(name3)'" {
                    matrix `betainfo'[8,`ibnm'] = 1 // self
                    matrix `betainfo'[9,`ibnm'] = 1 // self only
                    matrix `betainfo'[10,`ibnm'] = 0 // intother
                }
                else {
                    matrix `betainfo'[8,`ibnm'] = 0 // self
                    matrix `betainfo'[9,`ibnm'] = 0 // self only
                    matrix `betainfo'[10,`ibnm'] = 1 // intother
                }

            }
            else if `deg2'==1 {
                if "`r(name1)'"=="`r(name2)'" {
                    matrix `betainfo'[8,`ibnm'] = 1 // self
                    matrix `betainfo'[9,`ibnm'] = 1 // self only
                    matrix `betainfo'[10,`ibnm'] = 0 // intother
                }
                else {
                    matrix `betainfo'[8,`ibnm'] = 0 // self
                    matrix `betainfo'[9,`ibnm'] = 0 // self only
                    matrix `betainfo'[10,`ibnm'] = 1 // intother
                }
            }
        } // interaction

        * is it omitted? base level?
        if "`corenm'"!="" {
            local ipos : list posof "`corenm'" in rhs_core
            if `ipos'>0 {
              * count omitted categories in variable
                local nomit = `varinfo'[5,`ipos']
                if ("`nomit'"==".") local nomit = 0
                local isomit `r(omit)'
                if "`isomit'"!="" {
                    if (`isomit'!=0) matrix `varinfo'[5,`ipos'] = `nomit'+1
                }
              * base category
                local isbase `r(base)'
                local islevel `r(level)'
                if "`isbase'"!="" {
                    if (`isbase'==1) matrix `varinfo'[4,`ipos'] = `islevel'
                }
                forvalues i = 1(1)10 {
                    matrix `betainfo'[`i',`ibnm'] = `varinfo'[`i',`ipos']
                }
            }
        }

        * labeled as variable?
        *local isvariable = 0
        *if ("`r(type)'"=="variable") local isvariable = 1
        * labeled as factor?
        local isfactor = 0
        if ("`r(type)'"=="factor") local isfactor = 1
        local isomit = r(omit)
        local ilevel = r(level)
        matrix `betainfo'[11,`ibnm'] = `isfactor'
        matrix `betainfo'[12,`ibnm'] = `isomit'
        matrix `betainfo'[13,`ibnm'] = `ilevel'

    } // columns of e(b)
*/

//  returns

*  return matrix betainfo = `betainfo'
return matrix varinfo = `varinfo'

return local cmdnm "`cmdnm'"
return local cmdbin "`cmdbin'"
return local cmdnrm "`cmdnrm'"
return local cmdcrm "`cmdcrm'"
return local cmdsvy "`cmdsvy'"
return local cmdn "`cmdn'"

return local lhsnm "`lhsnm'"
return local lhsnm2 "`lhsnm2'" // for intreg
return local lhsbaseval `lhsbaseval'
return local lhsvalues "`lhsvalues'"
return local lhscatn "`lhscatn'"
return local lhscatnms "`lhscatnms'"
return local lhscatnms8 "`lhscatnms8'"
return local lhscatvals "`lhscatvals'"

return local rhsnms "`rhsnms'"
return local rhsn `rhsn'
return local rhsnms2 "`rhsnms2'"
return local rhsn2 `rhsn2'

return local rhs_core "`rhs_core'"
return local rhs_bin "`rhs_bin'"
return local rhs_cat "`rhs_cat'"
return local rhs_typeintprod "`rhs_typeintprod'"
return local rhs_typefactor "`rhs_typefactor'"
return local rhs_nfactor "`rhs_nfactor'"
return local rhs_typevariable "`rhs_typevariable'"

return local rhs2_core "`rhs2_core'"
return local rhs2_bin "`rhs2_bin'"
return local rhs2_cat "`rhs2_cat'"
return local rhs2_typeintprod "`rhs2_typeintprod'"
return local rhs2_typefactor "`rhs2_typefactor'"
return local rhs2_nfactor "`rhs2_nfactor'"
return local rhs2_typevariable "`rhs2_typevariable'"

end

/*
syntax: fvtype, rhsnms

rhs_typevariable
rhs_typefactor
rhs_typeinteraction
rhs_core
rhs_isbin
rhs_iscat
rhs_isint
rhs_isintself
rhs_isintselfonly
rhs_isintother
*/

program define fvtype, sclass

    version 11.2
    syntax , rhs_beta(string)
    local q ""
local debug "noi"
    local q "qui"

    tempname betas
    matrix `betas' = e(b)
    local betanms : colnames `betas'

    local listnms "typevariable typefactor typeintprod core bin cat"
    * if want details on interactions, use these
*    local listnms "`listnms' isint isintself isintselfonly isintother"

    * loop through parameters
    foreach bnm in `betanms' {
        _ms_parse_parts `bnm'
        *`debug' di _new "_ms_parse_parts `bnm'"
        *`debug' return list

        if inlist(r(type), "interaction", "product") {
*`debug' di "!!!inter ============================================"
            local k_names = r(k_names)
            forvalues inm = 2/`k_names' {
                local rhs_core "`rhs_core'`r(name`inm')' "
                local rhs_typeintprod "`rhs_typeintprod'`r(name`inm')' "
            }
        }
        else if r(type) == "variable" {
*`debug' di "!!! var ============================================"
            local rhs_typevariable "`rhs_typevariable'`r(name)' "
            local rhs_core "`rhs_core'`r(name)' "
        }
        else if r(type) == "factor" {
*`debug' di "!!! factor ============================================"
            local rhs_typefactor "`rhs_typefactor'`r(name)' "
            local rhs_core "`rhs_core'`r(name)' "
            * collect names from 1.x 2.x 3.x to see if bin or cat
            local `r(name)' "``r(name)''`r(name)' "
        }
        else {
            di as error "unexpected r(type). fatal error."
            exit
        }
    }

    * binary or categorical factor
    local rhs_typefactor : list uniq rhs_typefactor
    foreach nm in `rhs_typefactor' {
        local dupnms : list dups `nm'
        local nfactor : list sizeof dupnms
        local ++nfactor
        local rhs_nfactor "`rhs_nfactor'`nfactor' "
        if `nfactor'==2 local rhs_bin "`rhs_bin'`nm' "
        else local rhs_cat "`rhs_cat'`nm' "
    }

    * cleanup and returns
    foreach lnm in `listnms' {
        local rhs_`lnm' : subinstr local rhs_`lnm' "_cons" " ", all
        local rhs_`lnm' : list uniq rhs_`lnm'
*`debug' di "rhs_`lnm': `rhs_`lnm''"
        sreturn local rhs_`lnm' "`rhs_`lnm''"
    }
    sreturn local rhs_nfactor "`rhs_nfactor'"

end

exit

OLD CODE
/*
    //  loop over core names to determine how used as factor variables

    local rhs_fvbin ""
    local rhs_fvcat ""
    local rhs_notfv "" // no fv stuff, simple variable
    local rhs_fvint ""
    local rhs_fvintself ""
    local rhs_fvintother ""

    foreach corenm of local rhs_core {

    `q' di _new "=========================================================="
    `q' di _new "Testing core variable: `corenm'" _new

        local coresimple = 1

        //  loop over beta's created with factor variables

        foreach betanm of local rhs_beta {

            *di "testing beta: `betanm'" _col(30) "betaword: `betaword'"

            * turn betanm into words
            * # to space
            local betaword : subinstr local betanm "#"  " ", all
            * c. to space
            local betaword : subinstr local betaword "c." " ", all
            * remove #.
            local betaword = regexr("`betaword'","[0-9]+\."," ")
            local betaword = regexr("`betaword'","[0-9]+\."," ")
            local betaword = regexr("`betaword'","[0-9]+\."," ")
            local betaword = regexr("`betaword'","[0-9]+\."," ")
            local betaword = regexr("`betaword'","[0-9]+\."," ")
            local betaword : list retokenize betaword

            local ibetapos : list posof "`corenm'" in betaword

            //  no core in betaword: skip to next betanm

            if `ibetapos'==0 {
`q' di "  corenm (`corenm') is not betanm (`betanm') 1" _new
            }

            //  yes core in beta: decide if 1. 2. #

            else { // corenm is IN betanm
`q' di "  corenm (`corenm') is IN betanm (`betanm') 2" _new

                local iscorei1 = regexm("`betanm'","1.`corenm'")

                //  yes i1. in beta
                if `iscorei1'== 1{
`q' di "     (1.`corenm') is IN betanm (`betanm') 3" _new
                    local coresimple = 0
                    local rhs_fvbin "`rhs_fvbin'`corenm' "
                }

                //  no i1 in beta
                else {
`q' di "     (1.`corenm') not in betanm (`betanm') 4" _new
                }

                local iscorei2 = regexm("`betanm'","[2-9]+\.`corenm'")

                //  yes i2+ in betanm
                if `iscorei2'== 1 {
`q' di "     (2+.`corenm') is IN betanm (`betanm') 5" _new
                    local coresimple = 0
                    local rhs_fvcat "`rhs_fvcat'`corenm' "
                    local rhs_fvbin : list rhs_fvbin - corenm
                }

                //  no i2+ in beta
                else {
`q' di "     (2+.`corenm') not in betanm (`betanm') 6" _new
                }

                local iscorepound = regexm("`betanm'","#")

                //  yes # in beta

                if `iscorepound'== 1 {
`q' di "     (#) is IN betanm (`betanm')" _new
                    local coresimple = 0
                    local rhs_fvint "`rhs_fvint'`corenm' "
                    local beta_core : list betaword - corenm
                    local beta_core : list uniq beta_core
                    local beta_core : list retokenize beta_core

                    //  yes only core in #
                    if "`beta_core'"=="`corenm'" {
`q' di "        - # corenm only `corenm' ( `betanm' ) 7" _new
                        local coresimple = 0
                        local rhs_fvintself "`rhs_fvintself'`corenm' "
                    }

                    //  not only core in beta
                    else {
`q' di "        - #xy -> # core `corenm' plus ( `betanm' ) 8" _new
                        local coresimple = 0
                        local rhs_fvintother "`rhs_fvintother'`corenm' "
                    }

                } // # in beta

                //  no # in beta: next beta

                else {
`q' di "     (#) not in betanm (`betanm') 9" _new
                } // no # in beta

            } // core in betaword

        } // next betanm

        if `coresimple'==1 local rhs_notfv "`rhs_notfv'`corenm' "

    } // next corenm

    local rhs_fvintselfonly : list rhs_fvintself - rhs_fvintother
    local rhs_fv : list rhs_core - rhs_notfv

//  clean up and create returns

    foreach fv in rhs_fvbin rhs_fvcat rhs_notfv rhs_fvint rhs_fvintself ///
        rhs_fvintother rhs_fvintselfonly rhs_notfv {
        local `fv' : list uniq `fv'
        * 120 local `fv' : list sort `fv'
        local `fv' : list retokenize `fv'
        `q' di "`fv'" _col(25) "``fv''"
    }

    `q' di _new "beta_sorted: `rhs_beta'"

    foreach rhs in rhs_core rhs_fv rhs_notfv rhs_fvbin rhs_fvcat ///
        rhs_fvint rhs_fvintselfonly rhs_fvintself rhs_fvintother {
        local `rhs' = strtrim("``rhs''")
    }

    sreturn local rhs_core          "`rhs_core'"
    sreturn local rhs_fv            "`rhs_fv'"
    sreturn local rhs_notfv         "`rhs_notfv'"
    sreturn local rhs_fvbin         "`rhs_fvbin'"
    sreturn local rhs_fvcat         "`rhs_fvcat'"
    sreturn local rhs_fvint         "`rhs_fvint'"
    sreturn local rhs_fvintselfonly "`rhs_fvintselfonly'"
    sreturn local rhs_fvintself     "`rhs_fvintself'"
    sreturn local rhs_fvintother    "`rhs_fvintother'"
*/


DEBUG CODE
/*
di "lhscatn:    `lhscatn'"
di "lhscatnms8: `lhscatnms8'"
di "lhscatnms:  `lhscatnms'"
di "lhscatvals: `lhscatvals'"
*/
